#pragma once
#include <vector>
#include <cstdint>
#include "elements.h"
#include <algorithm>
#include <functional>
#include <iterator>
#include <set>
#include <list>
#include <map>
#include "Exeption.h"
#include <unordered_set>


using namespace std;
class MeshLoader
{
private:

protected:
	void add_node(const Node& a);
	void add_Finite_Element(const Finite_element& a);
	void add_BFE(const Boundary_Finite_element& a);
	vector<Boundary_Finite_element> BFE;
	vector <Finite_element> FE;
	vector<Node> node;
public:
	friend Node;
	friend Node UI_to_N (uint16_t a, const MeshLoader& b);
	virtual void LoadMesh(const std::string& str) = 0;
	const vector<Boundary_Finite_element>& getBoundary_Finite_Element();
	const vector<Finite_element>& getFinite_Element();
	const vector<Node>& get_nodes();
	vector<Finite_element> findFinite_Element(const uint16_t& one_id, const uint16_t& two_id, const uint16_t& three_id);
	vector<Finite_element> findFinite_Element(const uint16_t& one_id, const uint16_t& two_id);
	set<Node> find_nodes(const uint16_t& id_granitsi);
	vector<Finite_element> findFinite_Element(const uint16_t& id_materiala);
	vector<Boundary_Finite_element> findBoundary_Finite_Element(const uint16_t& id_granitsi);
	map<uint16_t, set<uint16_t>> find_neighbors();
	void insertt();
	Node mid_elem(uint16_t c, uint16_t d);
	vector<Boundary_Finite_element> findBoundary_Finite_Element(uint16_t one_id, uint16_t two_id);
};

class Edge
{

public:
	vector<uint16_t> nodes; //!!! Логичнее было бы хранить 3 поля - начало, конец и середину
	Edge operator =(const Edge& a)
	{
		this->nodes = a.nodes;
	}
	bool operator ==(const Edge& a)
	{
		int d = 0;
		for (int i = 0; i < 2; i++)
		{
			if ((this->nodes[i] == a.nodes[0]) || (this->nodes[i] == a.nodes[1]))
				d++;
		}
		return d == 2;
	}
	
	const vector<uint16_t>& get_nodes()
	{
		return nodes;
	}
	Edge(uint16_t a, uint16_t b)
	{
		nodes.reserve(3);
		nodes[0]=a;
		nodes[1]=b;
	}
	void insert(const Node& a)
	{
		nodes.push_back(a.n_id);
	};
	void insert(uint16_t a)
	{
		nodes.push_back(a);
	}
	int count()
	{
		return nodes.size();
	};
	friend bool operator ==(const Edge& a, const Edge& b);
	friend class fed;
	friend class EdgeHash;
	//friend Edge findEdge(uint16_t id1, uint16_t id2,const unordered_set<Edge, EdgeHash>& sett);
};

inline void hashCombine(std::size_t& o_seed, const Edge& p_val)
{
	uint16_t a = p_val.nodes[0];
	uint16_t b = p_val.nodes[1];
	if (a > b)
	{
		uint16_t c = a;
		a = b;
		b = c;
	}
	o_seed ^= std::hash <uint16_t>() (a) + std::hash <uint16_t>() (b) + 0x9e3779b9 + (o_seed << 6) + (o_seed >> 2);
}

inline void hashVal(std::size_t & o_seed,const Edge& p_val)
{
	hashCombine(o_seed, p_val);
}

inline std::size_t hashVal(const Edge& a)
{
	std::size_t seed = 0;
	hashVal(seed, a);
	return seed;
}

class EdgeHash
{
public:
	std::size_t operator () (const Edge& p_c) const
	{
		return hashVal(p_c);
	}
};

